SystemOrganization addCategory: #'GT-GlamourDebugger'!

Object subclass: #GTDebuggingStone
	instanceVariableNames: 'pragma session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-GlamourDebugger'!

!GTDebuggingStone class methodsFor: 'instance creation' stamp: 'AndreiChis 8/8/2013 18:48'!
forPragma: aPragma forSession: aSession

	^ self new forPragma: aPragma forSession: aSession! !

!GTDebuggingStone methodsFor: 'selectors' stamp: 'AndreiChis 8/9/2013 14:37'!
actionSelector

	^ ('stepTo', (pragma argumentAt: 1) capitalized) asSymbol! !

!GTDebuggingStone methodsFor: 'selectors' stamp: 'AndreiChis 8/9/2013 14:36'!
activeSelector

	^ ('is', (pragma argumentAt: 1) capitalized, 'Valid') asSymbol! !

!GTDebuggingStone methodsFor: 'actions' stamp: 'AndreiChis 8/9/2013 14:43'!
completeAction

	^ self perform: self actionSelector withEnoughArguments: (Array with: self session context)! !

!GTDebuggingStone methodsFor: 'initialization' stamp: 'AndreiChis 8/8/2013 18:28'!
forPragma: aPragma forSession: aSession
	
	pragma := aPragma.
	session := aSession! !

!GTDebuggingStone methodsFor: 'testing' stamp: 'AndreiChis 8/9/2013 14:32'!
isActive

	^ (self class canUnderstand: self activeSelector) 	
		ifFalse: [ true ]
		ifTrue: [ self perform: self activeSelector ]! !

!GTDebuggingStone methodsFor: 'testing' stamp: 'AndreiChis 8/9/2013 14:48'!
reachedTarget

	^ (self class canUnderstand: self tagetSelector) 	
		ifFalse: [ true ]
		ifTrue: [ self perform: self tagetSelector ]! !

!GTDebuggingStone methodsFor: 'accessing' stamp: 'AndreiChis 8/8/2013 18:28'!
session

	^ session! !

!GTDebuggingStone methodsFor: 'selectors' stamp: 'AndreiChis 8/9/2013 14:46'!
tagetSelector

	^ ('has', (pragma argumentAt: 1) capitalized, 'ReachedTarget') asSymbol! !

GTDebuggingStone subclass: #GTGlamourDebuggingStone
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-GlamourDebugger'!

!GTGlamourDebuggingStone methodsFor: 'private' stamp: 'VincentBlondeau 2/14/2014 16:51'!
glamourValueDeliveryPredicate
	^ self session
		createPredicateForBlock: [ :aContext | 
			aContext selector = #glamourValueWithArgs:
				and: [ 
					aContext peekInstruction arguments notEmpty
						and: [ #(#value #valueWithArguments:) includes: aContext peekInstruction argument ] ] ]! !

!GTGlamourDebuggingStone methodsFor: 'testing context' stamp: 'AndreiChis 8/9/2013 17:39'!
hasPresentationConditionReachedTarget

	^ true
	"^ self session context peekInstruction arguments size = 1 and: [
		self session context peekInstruction argument = #condition ]"! !

!GTGlamourDebuggingStone methodsFor: 'testing receiver' stamp: 'AndreiChis 8/9/2013 17:56'!
isPresentationConditionValid

	^ (self session context receiver condition 
		ifNil: [ false ]
		ifNotNil: [ :aBlock |  aBlock printString ~= [true] printString ])! !

!GTGlamourDebuggingStone methodsFor: 'testing receiver' stamp: 'AndreiChis 8/9/2013 17:56'!
isPresentationCreationValid

	^ self session context receiver presentationsFactory notNil
	! !

!GTGlamourDebuggingStone methodsFor: 'testing receiver' stamp: 'AndreiChis 8/9/2013 17:56'!
isTransmissionConditionValid

	^ self session context receiver condition isBlock! !

!GTGlamourDebuggingStone methodsFor: 'testing receiver' stamp: 'AndreiChis 8/9/2013 17:56'!
isTransmissionTransformationValid

	^ self session context receiver transformation notNil! !

!GTGlamourDebuggingStone methodsFor: 'actions' stamp: 'AndreiChis 8/26/2013 11:49'!
stepToGlamourValueBlock

	self session stepUntil: self glamourValueDeliveryPredicate from: self session context.
	self session isActive ifTrue: [ 
		self session stepInto ].
	^ true! !

!GTGlamourDebuggingStone methodsFor: 'actions' stamp: 'AndreiChis 8/26/2013 11:49'!
stepToPresentationCondition
	| ctxt |

	ctxt := self session context.
	self session 
		stepUntil: ((self session createPredicateForBlock: [ ctxt isDead ]) or:  self glamourValueDeliveryPredicate)
		from: self session context.
		
	ctxt isDead not ifTrue: [ 
		self session stepInto ].
	
	^ ctxt isDead not! !

!GTGlamourDebuggingStone methodsFor: 'actions' stamp: 'AndreiChis 8/9/2013 17:59'!
stepToPresentationCreation
	
	^ self stepToGlamourValueBlock! !

!GTGlamourDebuggingStone methodsFor: 'actions' stamp: 'AndreiChis 8/9/2013 18:00'!
stepToTransmissionCondition

	^ self stepToGlamourValueBlock! !

!GTGlamourDebuggingStone methodsFor: 'actions' stamp: 'AndreiChis 8/9/2013 18:00'!
stepToTransmissionTransformation

	^ self stepToGlamourValueBlock! !

GTDebuggerSmokeTest subclass: #GTGlamourDebuggerSmokeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-GlamourDebugger'!

!GTGlamourDebuggerSmokeTest methodsFor: 'accessing' stamp: 'AndreiChis 12/19/2013 16:09'!
debuggerToTest

	^ GTGlamourDebugger! !

!GTGlamourDebuggerSmokeTest methodsFor: 'utils' stamp: 'AndreiChis 1/22/2016 19:59'!
stepToStartOnContext

	^ [:aProcess |
	aProcess 
		step;
		step;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		step; "send openOn:"
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		step; "send openOn:with:"
		completeStep: aProcess suspendedContext;
		completeStep: aProcess suspendedContext;
		step "send startOn:" ]! !

!GTGlamourDebuggerSmokeTest methodsFor: 'tests' stamp: 'AndreiChis 1/22/2016 19:59'!
testDebugger

	self 
		assertDebuggerInitializationForContext: [GLMBasicExamples open] asContext 
		andStepBlock: self stepToStartOnContext.

 	self assertDebuggerClosing.! !

DebugSession subclass: #GTGlamourDebugSession
	instanceVariableNames: 'rootBrowserContext'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-GlamourDebugger'!

!GTGlamourDebugSession methodsFor: 'predicates creation' stamp: 'AndreiChis 8/8/2013 16:42'!
createStepPredicateForPredicate: aPredicate 

	^ (self createPredicateForBlock: [ self isActive not ]) or: aPredicate
	! !

!GTGlamourDebugSession methodsFor: 'testing' stamp: 'AndreiChis 8/8/2013 16:42'!
isActive

	^ rootBrowserContext  
		ifNil: [ false ] 
		ifNotNil: [ 
			rootBrowserContext isDead not and: [
				
				rootBrowserContext ~= self process suspendedContext or: [rootBrowserContext willReturn not ]
				
				 ]  ]! !

!GTGlamourDebugSession methodsFor: 'initialization' stamp: 'AndreiChis 8/8/2013 16:46'!
process: aProcess context: aContext

	super process: aProcess context: aContext.
	
	self flag: 'Have a method that is only called when the session is created and put this there'.
	rootBrowserContext ifNil:  [
		rootBrowserContext := aContext locateBrowserContext ]! !

!GTGlamourDebugSession methodsFor: 'accessing' stamp: 'AndreiChis 8/8/2013 16:41'!
rootBrowser

	^ rootBrowserContext receiver! !

!GTGlamourDebugSession methodsFor: 'accessing' stamp: 'AndreiChis 8/8/2013 16:41'!
rootBrowserContext

	^ rootBrowserContext! !

!Context methodsFor: '*GT-GlamourDebugger' stamp: 'AndreiChis 1/5/2015 16:57'!
locateBrowserContext

	^ (self findContextSuchThat:  [ :ctx | 
		(ctx receiver class inheritsFrom: GLMPresentation) " and: [ ctx selector = #startOn: ]" ]) ! !

DebugAction subclass: #GTGlamourStepToNextStoneAction
	instanceVariableNames: 'debugStoneType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-GlamourDebugger'!

!GTGlamourStepToNextStoneAction class methodsFor: 'accessing' stamp: 'AndreiChis 8/11/2013 18:40'!
debuggingStonePragma

	^ #debuggingStone:label:! !

!GTGlamourStepToNextStoneAction class methodsFor: 'registration' stamp: 'AndreiChis 9/9/2013 13:57'!
gtActionFor: aDebugger
	<gtGlamourDebuggingAction>
	<gtContextGlamourDebuggingAction>
	

	^ (self forDebugger: aDebugger)
		label: 'Any action'
	
	! !

!GTGlamourStepToNextStoneAction class methodsFor: 'registration' stamp: 'AndreiChis 9/9/2013 13:57'!
gtGoToDebugingStoneActionsFor: aDebugger
	<gtGlamourDebuggingAction>
	<gtContextGlamourDebuggingAction>
	
	^(PragmaCollector filter: [:prag | 
		prag keyword = self debuggingStonePragma ]) reset collected collect: [ :aPragma |
			(self forDebugger: aDebugger)
				label: (aPragma argumentAt: 2);
				"category: 'Debugging Stone';"
				debugStoneType: (aPragma argumentAt: 1) ]

	! !

!GTGlamourStepToNextStoneAction methodsFor: 'testing' stamp: 'AndreiChis 8/8/2013 17:04'!
appliesToContext: aContext

	^ aContext locateBrowserContext notNil! !

!GTGlamourStepToNextStoneAction methodsFor: 'accessing' stamp: 'AndreiChis 8/9/2013 18:01'!
debugStoneType
	
	^ debugStoneType! !

!GTGlamourStepToNextStoneAction methodsFor: 'accessing' stamp: 'AndreiChis 8/9/2013 18:01'!
debugStoneType: anObject
	
	debugStoneType := anObject! !

!GTGlamourStepToNextStoneAction methodsFor: 'predicates' stamp: 'AndreiChis 8/11/2013 18:36'!
debuggingStonePredicate

	^ self session createPredicateForBlock: [ :aContext |
			aContext isInitialnstruction and: [ | pragma |
				pragma := aContext method pragmaAt: self class debuggingStonePragma.
				pragma notNil and: [ 
					self debugStoneType isNil or: [ (pragma argumentAt: 1) = self debugStoneType ] ] ] ]! !

!GTGlamourStepToNextStoneAction methodsFor: 'actions' stamp: 'AndreiChis 8/9/2013 17:39'!
executeAction
	| debugingStone |
	
	"The first time start searching for a debuging stone from the context selected by the user."
	debugingStone := self stepToDebuggingStoneFrom: self currentContext.

	[ debugingStone notNil ]
		whileTrue: [ 
			(debugingStone reachedTarget and: [ 
				debugingStone isActive and: [ 
					debugingStone completeAction ] ]) 
						"After the first time use the interruptedContext (start the search from where it was left of).
						Here the interruptedContext it is the same as the suspended context of the process."
						ifFalse: [ debugingStone := self stepToDebuggingStoneFrom: self interruptedContext ]
						"If a debuging stone reached its destination stop the search."
						ifTrue: [ ^ self ] ]
	! !

!GTGlamourStepToNextStoneAction methodsFor: 'actions' stamp: 'AndreiChis 8/26/2013 11:49'!
stepToDebuggingStoneFrom: aContext

	"Make sure the execution advances, and does not check the same context."
	self session stepInto: aContext.

	self session 
		stepUntil: self debuggingStonePredicate
		from: self interruptedContext.
		
	^ self session isActive 
		ifTrue: [ 
			GTGlamourDebuggingStone 
				"Here interruptedContext is the same as the suspended context of the process."
				forPragma: (self interruptedContext method pragmaAt: self class debuggingStonePragma) 
				forSession: self session  ]
		ifFalse: [ nil ]! !

DebugAction subclass: #GTGlamourStepToPresentationBuildAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-GlamourDebugger'!

!GTGlamourStepToPresentationBuildAction class methodsFor: 'registration' stamp: 'AndreiChis 8/9/2013 12:17'!
gtActionType
	"<gtContextGlamourDebuggingAction>"! !

!GTGlamourStepToPresentationBuildAction methodsFor: 'testing' stamp: 'AndreiChis 8/8/2013 16:35'!
appliesToContext: aContext

	^ aContext locateBrowserContext notNil! !

!GTGlamourStepToPresentationBuildAction methodsFor: 'actions' stamp: 'AndreiChis 8/26/2013 11:50'!
executeAction
	| presentationCreation presentationCode |
	presentationCreation := self presentationCreationPredicate.
	presentationCode := self presentationCodePredicate.

	self session stepUntil: presentationCreation from: self currentContext.
	self session stepUntil: presentationCode from: self interruptedContext.
	self session isActive ifTrue: [ 
		self session stepInto ]
		
	! !

!GTGlamourStepToPresentationBuildAction methodsFor: 'initialize-release' stamp: 'AndreiChis 6/27/2013 11:49'!
initialize

	self label: 'Next presentation build'.
	self icon: GLMUIThemeExtraIcons glamorousPlay.! !

!GTGlamourStepToPresentationBuildAction methodsFor: 'predicates' stamp: 'VincentBlondeau 2/14/2014 16:51'!
presentationCodePredicate
	^ self session
		createPredicateForBlock: [ :aContext | 
			aContext selector = #glamourValueWithArgs:
				and: [ 
					aContext peekInstruction arguments notEmpty
						and: [ #(#value #valueWithArguments:) includes: aContext peekInstruction argument ] ] ]! !

!GTGlamourStepToPresentationBuildAction methodsFor: 'predicates' stamp: 'AndreiChis 8/8/2013 16:47'!
presentationCreationPredicate

	^ self session createPredicateForBlock: [ :aContext |
			aContext methodClass = GLMPresentStrategy and: [ 
				aContext selector = #presentations and: [ 
					aContext isInitialnstruction ] ] ]

! !

DebugAction subclass: #GTPPStepToGlamourDebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-GlamourDebugger'!

!GTPPStepToGlamourDebugger class methodsFor: 'registration' stamp: 'AndreiChis 1/20/2015 22:03'!
gtActionType
	<gtDebuggingAction>! !

!GTPPStepToGlamourDebugger methodsFor: 'testing' stamp: 'AndreiChis 9/9/2013 14:11'!
appliesToContext: aContext
	
	^ self debugger class ~= self debuggerClass! !

!GTPPStepToGlamourDebugger methodsFor: 'accessing' stamp: 'AndreiChis 9/9/2013 14:07'!
debuggerClass
	
	^ GTGlamourDebugger! !

!GTPPStepToGlamourDebugger methodsFor: 'accessing' stamp: 'AndreiChis 9/9/2013 14:07'!
defaultCategory
	
	^ 'Step to debugger'! !

!GTPPStepToGlamourDebugger methodsFor: 'accessing' stamp: 'AndreiChis 9/9/2013 14:06'!
defaultLabel 
	
	^ self debuggerClass defaultTitle! !

!GTPPStepToGlamourDebugger methodsFor: 'accessing' stamp: 'AndreiChis 12/29/2013 17:09'!
defaultOrder

	^ 150! !

!GTPPStepToGlamourDebugger methodsFor: 'actions' stamp: 'AndreiChis 9/9/2013 14:08'!
executeAction

	self session
		stepUntil: (self session 
			createStepPredicateForPredicate: self isGlamourDebuggerActivePredicate 
			fromContext: self currentContext ) 
		from: self currentContext.
		
	(self isGlamourDebuggerActivePredicate matches: self interruptedContext) ifTrue: [ 
		self debugger debug: self interruptedContext using: self debuggerClass ]
! !

!GTPPStepToGlamourDebugger methodsFor: 'accessing' stamp: 'AndreiChis 10/2/2018 19:02'!
help
	^ 'Resume execution until a Glamour browser is opened'! !

!GTPPStepToGlamourDebugger methodsFor: 'testing' stamp: 'AndreiChis 9/9/2013 14:11'!
isGlamourDebuggerActivePredicate

	^ self session createPredicateForBlock: [ :aContext |
		(aContext receiver class inheritsFrom: GLMPresentation) and: [ aContext selector = #startOn: ]  ]! !

GTGenericStackDebugger subclass: #GTGlamourDebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-GlamourDebugger'!

!GTGlamourDebugger class methodsFor: 'accessing' stamp: 'TudorGirba 1/17/2016 22:13'!
defaultTitle

	^ 'Glamour'! !

!GTGlamourDebugger class methodsFor: 'testing' stamp: 'AndreiChis 8/8/2013 16:36'!
handlesContext: aContext

	^ aContext locateBrowserContext notNil ! !

!GTGlamourDebugger class methodsFor: 'tools registry' stamp: 'AndreiChis 12/31/2013 21:01'!
register

	self registerToolsOn: Smalltalk tools.! !

!GTGlamourDebugger class methodsFor: 'tools registry' stamp: 'AndreiChis 7/15/2013 16:39'!
registerToolsOn: registry

	"Add ourselves to registry. See [Smalltalk tools]" 
	registry registerDebugger: self withRank: 50.! !

!GTGlamourDebugger class methodsFor: 'private' stamp: 'AndreiChis 8/8/2013 16:45'!
sessionClass

	^ GTGlamourDebugSession! !

!GTGlamourDebugger methodsFor: 'building' stamp: 'TudorGirba 10/24/2014 23:04'!
browserStructureFor: aGlmBrowser in: aComposite
	
	aComposite roassal2
		title: 'Browser structure';
		painting: [:view :b | 
			aGlmBrowser viewTreeOn: view ]! !

!GTGlamourDebugger methodsFor: 'building' stamp: 'AndreiChis 6/24/2013 20:53'!
debuggerStructureIn: browser

	browser
			row: [ :row | 
						row
							column: [ :c |
								c
									row: #stack;
									row: #code ];
							column: #browser ] span: 4;
			row: #inspector span: 3.! !

!GTGlamourDebugger methodsFor: 'building' stamp: 'AndreiChis 12/17/2013 11:16'!
debuggerTransmissionsIn: browser.
		
	super debuggerTransmissionsIn: browser.
	
	browser transmit
		from: #stack port: #selection;
		to: #browser;
		andShow: [ :composite | self browserStructureFor: self session rootBrowser in: composite ]! !

!GTGlamourDebugger methodsFor: 'building actions' stamp: 'AndreiChis 6/27/2013 12:17'!
debuggingActionsPragmas

	^ super debuggingActionsPragmas, { #glamourDebuggingAction }! !
